_G.DailyDeeds = {}
DailyDeeds.frame = CreateFrame("frame", "RenewingMistTracker")

--Functions
function SaveQuest(title, level, isLowLevel, isDaily, isRepeatable)
  zone = GetZoneText()
  if DailyDeedsDB[zone] == nil then
    DailyDeedsDB[zone] = {}
  end
  local x, y = GetCursorPosition();
  DailyDeedsDB[zone][title] = {
    title = title,
    level = level,
    isLowLevel = isLowLevel,
    isDaily = isDaily,
    isRepeatable = isRepeatable,
    location = {x = x, y = y}
  }
end

function SaveQuestFromAccept(title, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, questID, startEvent, displayQuestID)
  if DailyDeedsDB['ids'] == nil then
    DailyDeedsDB['ids'] = {}
  end
  DailyDeedsDB['ids'][questID] = title

  zone = GetZoneText()
  if DailyDeedsDB[zone] == nil then
    DailyDeedsDB[zone] = {}
  end
  if DailyDeedsDB[zone][title] == nil then
    DailyDeedsDB[zone][title] = {}
  end
  local x, y = GetCursorPosition();
  DailyDeedsDB[zone][title]['title'] = title
  DailyDeedsDB[zone][title]['level'] = level
  DailyDeedsDB[zone][title]['questTag'] = questTag
  DailyDeedsDB[zone][title]['suggestedGroup'] = suggestedGroup
  DailyDeedsDB[zone][title]['isHeader'] = isHeader
  DailyDeedsDB[zone][title]['isCollapsed'] = isCollapsed
  DailyDeedsDB[zone][title]['isComplete'] = isComplete
  DailyDeedsDB[zone][title]['isDaily'] = isDaily
  DailyDeedsDB[zone][title]['questID'] = questID
  DailyDeedsDB[zone][title]['startEvent'] = startEvent
  DailyDeedsDB[zone][title]['displayQuestID'] = displayQuestID
  DailyDeedsDB[zone][title]['location'] = {x = x, y = y}
end


function ProcessQuests(...)
  local quests = {n=select('#', ...), ...}
  for i = 1, quests.n, 6 do
    if quests[i + 3] then
      SaveQuest(quests[i], quests[i +1], quests[i +2], quests[i +3], quests[i +1])
    end
  end
end

local completingQuest = false
--Register Events
local eventCallbacks = {
  ADDON_LOADED = function(...)
    if DailyDeedsDB == nil then
      DailyDeedsDB = {};
    end
    if DailyDeedsConfig == nil then
      DailyDeedsConfig = {};
    end
    DEFAULT_CHAT_FRAME:AddMessage("DailyDeeds Loaded!")
  end,
  PLAYER_LOGIN = function(...)
    _G.DailyDeeds.UI:LoadFrame()
    _G.DailyDeeds.CompletedQuests = GetQuestsCompleted()
    if DailyDeedsConfig['quests'] == nil then
      DailyDeedsConfig['quests'] = {}
    end
    DailyDeedsConfig['quests']["Townlong Steppes"] = {}
    DailyDeedsConfig['quests']["Timeless Isle"] = {}
    DailyDeedsConfig['quests']["Townlong Steppes"]["The Bigger They Come..."] = true 
    DailyDeedsConfig['quests']["Timeless Isle"]["Path of the Mistwalker"] = true
    for zone, quests in pairs(DailyDeedsConfig['quests']) do
      for quest, value in pairs(quests) do
        _G.DailyDeeds.UI:TrackQuest(zone, quest)
      end
    end
  end,
  GOSSIP_SHOW = function(...)
    ProcessQuests(GetGossipAvailableQuests())
  end,
  QUEST_ACCEPTED = function(...)
    local questLogIndex = select(1, ...)
    title, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, questID, startEvent, displayQuestID = GetQuestLogTitle(questLogIndex)
    if isDaily then
      SaveQuestFromAccept(title, level, questTag, suggestedGroup, isHeader, isCollapsed, isComplete, isDaily, questID, startEvent, displayQuestID)
    end
  end,
  QUEST_COMPLETE = function(...)
    completingQuest = true
  end,
  QUEST_LOG_UPDATE = function(...)
    if completingQuest == true then
      _G.DailyDeeds.CompletedQuests = GetQuestsCompleted()
      completingQuest = false
    end
  end
}
function OnEvent(self, event, ...)
  if eventCallbacks[event] then
    eventCallbacks[event](...)
  end
end

--Register Events
DailyDeeds.frame:RegisterEvent("PLAYER_LOGIN")
DailyDeeds.frame:RegisterEvent("ADDON_LOADED")
DailyDeeds.frame:RegisterEvent("GOSSIP_SHOW")
DailyDeeds.frame:RegisterEvent("QUEST_ACCEPTED")
DailyDeeds.frame:RegisterEvent("QUEST_COMPLETE")
DailyDeeds.frame:RegisterEvent("QUEST_LOG_UPDATE")



DailyDeeds.frame:SetScript("OnEvent", OnEvent)