_G.DailyDeeds.UI = {}
local frameLoaded = false
local questFrame
local quests = {}
local text = {}

function OnUpdate()
  for i=1, #text, 1 do
    if text[i] then
      text[i]:SetText("")
      text[i]:Hide()
    end
  end
  local row = 0
  for zoneName, value in pairs(quests) do
    row = row + 1
    local startingRow = row

    if text[row] == nil then
      text[row] = questFrame:CreateFontString(nil, "OVERLAY")
      text[row]:SetPoint("LEFT", questFrame, "LEFT", 1, -(5 + (row * 11)))
      text[row]:SetFont("Fonts\\FRIZQT__.TTF", 10, "OUTLINE")
      text[row]:SetJustifyH("LEFT")
      text[row]:SetShadowOffset(1, -1)
    end
    text[row]:SetTextColor(1, 1, 0.2)
    text[row]:SetText(zoneName)
    text[row]:Show()

    for questName, value in pairs(value) do
      local incomplete = true
      if DailyDeedsDB[zoneName][questName]['questID'] then
        if _G.DailyDeeds.CompletedQuests[DailyDeedsDB[zoneName][questName]['questID']] ~= nil then
          incomplete = false
        end
      end
      if incomplete then
        row = row + 1
        if text[row] == nil then
          text[row] = questFrame:CreateFontString(nil, "OVERLAY")
          text[row]:SetPoint("LEFT", questFrame, "LEFT", 11, -(5 + (row * 11)))
          text[row]:SetFont("Fonts\\FRIZQT__.TTF", 10, "OUTLINE")
          text[row]:SetJustifyH("LEFT")
          text[row]:SetShadowOffset(1, -1)
        end
        text[row]:SetTextColor(0.9, 0.9, 0.9)
        text[row]:SetText(questName)
        text[row]:Show()
      end
    end
    if startingRow == row then
      text[row]:SetText('')
      text[row]:Hide()
      row = row - 1
    else
      row = row + 1
    end
  end
end

function _G.DailyDeeds.UI:LoadFrame()
  questFrame = CreateFrame("Frame", "DailyDeeds", UIParent)

  questFrame:SetSize(204, 20)
  questFrame:SetPoint("CENTER", UIParent )
  questFrame:SetBackdrop({
      bgFile   = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16,
      edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 12,
      insets = { left = 3, right = 3, top = 3, bottom = 3, },
  })

  questFrame:SetMovable(true)
  questFrame:EnableMouse(true)
  questFrame:SetClampedToScreen( true )
  questFrame:RegisterForDrag("LeftButton")
  questFrame:SetUserPlaced(true)
  questFrame:SetScript("OnDragStart", questFrame.StartMoving)
  questFrame:SetScript("OnDragStop", questFrame.StopMovingOrSizing)

  -- Create the title text
  questFrame.titleText = questFrame:CreateFontString(nil, "OVERLAY")
  questFrame.titleText:SetPoint("CENTER", questFrame, "CENTER", 1, 1)
  questFrame.titleText:SetFont("Fonts\\FRIZQT__.TTF", 10, "OUTLINE")
  questFrame.titleText:SetJustifyH("LEFT")
  questFrame.titleText:SetShadowOffset(1, -1)
  questFrame.titleText:SetTextColor(0, 1, 0)
  questFrame.titleText:SetText("DailyDeeds")
  questFrame:Show()

  questFrame:SetScript("OnUpdate", OnUpdate )
  frameLoaded = true
end


function _G.DailyDeeds.UI:TrackQuest(zoneName, questName)
  if frameLoaded ~= true then
    _G.DailyDeeds.UI:LoadFrame()
  end
  if quests[zoneName] == nil then
    quests[zoneName] = {}
  end
  quests[zoneName][questName] = true
end